﻿using System;

namespace GameKnight.Core
{

	public interface IConsole : IReset
	{

		ICartridge Cartridge { get; }
	
		IController[] ControllerArray { get; }
		
		IInterface Interface { get; }

		//TODO: this has to go
		int InterruptMask { get; set; }
		
		IMemory Memory { get; }
	
		IProcessor Processor { get; }

		ISerializable[] SerializationArray { get; }
			
		IVideoMemory VideoMemory { get; }

		IVideoProcessor VideoProcessor { get; }

		IRegister GetRegister( int Address );

		T GetRegister<T>() where T : IRegister;

		void Load( IInputStream InputStream );
			
		void Update();
		
	}
	
}
