using System;
using GameKnight.Core;

namespace GameKnight.GameBoy
{
	
	public class Bank : IBank
	{
			
		private readonly byte[] DataArray = null;

		public int Length
		{
			get
			{
				return DataArray.Length;
			}
		}
		
		private readonly int Mask = 0;	
			
		public Bank( int Length )
		{
			this.DataArray = new byte[Length];
			this.Mask = ( Length - 1 );
			return;
		}
		
		public Bank( int Length, byte DefaultValue ) : this( Length )
		{
			for( int i = 0; i < Length; i++ )
			{
				DataArray[i] = DefaultValue;
			}
			return;
		}
			
		public Bank( byte[] DataArray )
		{
			this.DataArray = DataArray;
			this.Mask = ( Length - 1 );
			return;
		}
			
		public byte this[int Index]
		{
			get
			{
				unchecked
				{
					return DataArray[Index&Mask];
				}
			}
			set
			{
				unchecked
				{
					DataArray[Index&Mask] = value;
				}
			}
		}
		
	}
	
}


