using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public sealed partial class Cartridge : ICartridge
		{

				public sealed class MBC2 : Memory
				{
	
					public MBC2( IConsole Console, Cartridge Cartridge ) : base( Console, Cartridge )
					{
						RAM = new Bank[]{ new Bank( 0x200 ) };
						return;
					}

					public override void WriteU8( int Address, byte Value )
					{
						switch( Address & 0xE000 )
						{
							case 0x0000:
								if( ( Address & 0x0100 ) == 0 )
								{
									RAM_Enabled = ( ( Value & 0x0F ) == 0x0A );
								}
								break;
							case 0x2000:
								if( ( Address & 0x0100 ) != 0 )
								{
									ROM_BankIndex = ( Value & 0x0F );
									ROM_BankIndex %= ROM.Length;
									ROM_BankIndex = ( ( ROM_BankIndex == 0 ) ? 1 : ROM_BankIndex );
								}
								break;
							case 0xA000:
								if( ( RAM_Enabled ) && ( Address < 0xA200 ) )
								{
									RAM[0][Address] = Value;
								}
								break;
							default:
								base.WriteU8( Address, Value );
								break;
						}
						return;
					}	
					
				}
			
		}

	}
	
}


