using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public sealed partial class Cartridge : ICartridge
		{
			
				public class MBC5 : Memory
				{
	
					public MBC5( IConsole Console, Cartridge Cartridge ) : base( Console, Cartridge )
					{
						return;
					}
	
					public override void WriteU8( int Address, byte Value )
					{
						switch( Address & 0xE000 )
						{
							case 0x0000:
								RAM_Enabled = ( ( Value & 0x0A ) == 0x0A );
								break;
							case 0x2000:
								if( Address < 0x3000 )
								{
									ROM_BankIndex &= 0x100;
									ROM_BankIndex |= Value;
								}
								else
								{
									ROM_BankIndex &= 0xFF;
									ROM_BankIndex |= ( ( Value & 0x01 ) << 8 );
								}
								ROM_BankIndex %= ROM.Length;
								break;
							case 0x4000:
								if( RAM != null )
								{
									RAM_BankIndex = ( ( Value & 0x0F ) % RAM.Length );
								}
								break;
							default:
								base.WriteU8( Address, Value );
								break;
						}
						return;
					}	
					
				}
			
		}
		
	}
	
}
	
	
