﻿using System;
using GameKnight.Core;

namespace GameKnight
{
		
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
	
			private bool CarryFlag
			{
				get
				{
	        		return ( ( F & 0x10 ) != 0 );
				}
				set
				{
					if( value )
					{
						F |= 0x10;
					}
					else
					{
						F &= 0xEF;
					}
				}
			}
			
			private bool HalfCarryFlag
			{
				get
				{
	        		return ( ( F & 0x20 ) != 0 );
				}
				set
				{
					if( value )
					{
						F |= 0x20;
					}
					else
					{
						F &= 0xDF;
					}
				}
			}
			
			private bool NegativeFlag
			{
				get
				{
	        		return ( ( F & 0x40 ) != 0 );
				}
				set
				{
					if( value )
					{
						F |= 0x40;
					}
					else
					{
						F &= 0xBF;
					}
				}
			}
			
			private bool ZeroFlag
			{
				get
				{
	        		return ( ( F & 0x80 ) != 0 );
				}
				set
				{
					if( value )
					{
						F |= 0x80;
					}
					else
					{
						F &= 0x7F;
					}
				}
			}
			
			private void ClearFlags()
			{
				F &= 0x0F;
				return;
			}
			
		}
		
	}
	
}
