﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
			
				public static int CCF( Processor Processor, Opcode Opcode )
				{
					Processor.NegativeFlag = false;
					Processor.HalfCarryFlag = Processor.CarryFlag;
					Processor.CarryFlag = !Processor.CarryFlag;
					return 0;
				}
				
				public static int CPL( Processor Processor, Opcode Opcode )
				{
					Processor.A ^= 0xFF;
					Processor.NegativeFlag = true;
					Processor.HalfCarryFlag = true;		
					return 0;
				}
				
				public static int DAA( Processor Processor, Opcode Opcode )
				{
					ushort Index = Processor.A;
					if( Processor.CarryFlag )
					{
						Index |= 256;
					}
					if( Processor.HalfCarryFlag )
					{
						Index |= 512;
					}
					if( Processor.NegativeFlag )
					{
						Index |= 1024;
					}
					Processor.AF = DAA_Table[Index];
					return 0;
				}

				public static int DI( Processor Processor, Opcode Opcode )
				{
					Processor.IFF &= 0xDE; //( ~0x21 );
					//Processor.IME = false;
					return 0;
				}
				
				public static int EI( Processor Processor, Opcode Opcode )
				{
					Processor.IFF |= 0x20;
					//Processor.IME = true;
					return 0;
				}
				
				public static int HALT( Processor Processor, Opcode Opcode )
				{
					if( ( Processor.IFF & 0x01 ) != 0 )
					{
						Processor.PC--;
						Processor.IFF |= 0x80;
					}
					else
					{
						if( ( Processor.Memory.ReadU8( 0xFF0F ) & Processor.Memory.ReadU8( 0xFFFF ) ) != 0 )
						{
							Processor.IFF |= 0x100;		
						}
						else
						{
							Processor.PC--;
							Processor.IFF |= 0x81;
						}
					}				
					return 0;
				}
				
				public static int ILLEGAL( Processor Processor, Opcode Opcode )
				{
					//System.Diagnostics.Debug.Print( String.Format( "ILLEGAL INSTRUCTION {0:X2} AT {1:X4}", Opcode.Value, Processor.PC - 1 ) );
					return 0;
				}
				
				public static int NOP( Processor Processor, Opcode Opcode )
				{
					return 0;
				}
				
				public static int SCF( Processor Processor, Opcode Opcode )
				{
					Processor.CarryFlag = true;
					Processor.HalfCarryFlag = false;
					Processor.NegativeFlag = false;
					return 0;
				}
				
				public static int STOP( Processor Processor, Opcode Opcode )
				{
					/*Processor.PC++;
					if( Processor.KEY1 != null )
					{
						Processor.KEY1.SpeedSwitch();
					}*/
					return 0;
				}
				
			}
			
		}
		
	}
	
}
	
