﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
			
				public static int JP( Processor Processor, Opcode Opcode )
				{
					Processor.PC = Processor.Memory.ReadU16( Processor.PC );
					return 0;
				}
				
				public static int JP_CC( Processor Processor, Opcode Opcode )
				{
					ushort Address = Processor.Memory.ReadU16( Processor.PC );
					Processor.PC += 2;
					switch( (Conditions)( ( Opcode.Value >> 3 ) & 0x03 ) )
					{
						case Conditions.NZ:
							if( Processor.ZeroFlag == true )
							{
								return 0;
							}
							break;
						case Conditions.Z:
							if( Processor.ZeroFlag == false )
							{
								return 0;
							}
							break;
						case Conditions.NC:
							if( Processor.CarryFlag == true )
							{
								return 0;
							}
							break;
						case Conditions.C:
							if( Processor.CarryFlag == false )
							{
								return 0;
							}
							break;
					}
					Processor.PC = Address;
					return 0;
				}
				
				public static int JR( Processor Processor, Opcode Opcode )
				{
					Processor.PC = (ushort)( Processor.PC + 1 +  Processor.Memory.ReadS8( Processor.PC ) );
					return 0;
				}
				
				public static int JR_CC( Processor Processor, Opcode Opcode )
				{
					sbyte Offset = Processor.Memory.ReadS8( Processor.PC++ );
					switch( (Conditions)( ( Opcode.Value >> 3 ) & 0x03 ) )
					{
						case Conditions.NZ:
							if( Processor.ZeroFlag == false )
							{
								Processor.PC = (ushort)( Processor.PC + Offset );
								return 5;
							}
							break;
						case Conditions.Z:
							if( Processor.ZeroFlag == true )
							{
								Processor.PC = (ushort)( Processor.PC + Offset );
								return 5;
							}
							break;
						case Conditions.NC:
							if( Processor.CarryFlag == false )
							{
								Processor.PC = (ushort)( Processor.PC + Offset );
								return 5;
							}
							break;
						case Conditions.C:
							if( Processor.CarryFlag == true )
							{
								Processor.PC = (ushort)( Processor.PC + Offset );
								return 5;
							}
							break;
					}
					return 0;
				}
				
			}
			
		}
		
	}
	
}
	
	
	
	
	
