using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class Register : IRegister
		{
			
			public class BGP : Register, IPalette
			{

            	public uint[] ColorArray
				{
					get
					{
						return ColorArrayProperty;
					}
				}
				
				private readonly uint[] ColorArrayProperty = new uint[4];

				public int Entries
				{
					get
					{
						return ColorArray.Length;
					}
				}
				
				private uint[] GreyscaleTable = new uint[] { 0x00FFFFFF, 0x00AAAAAA, 0x00666666, 0x00000000 };

				public BGP() : base( 0xFC )
				{
					return;
				}
				
				public override byte this[int Address]
				{
					set
					{
						Value = value;
						for( int i = 0; i < ColorArray.Length; i++ )
						{
							ColorArray[i] = GreyscaleTable[((Value>>(i<<1))&0x03)];
						}
					}
				}

			}
			
		}
		
	}
	
}




