using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class Register : IRegister
		{
			
			public class DMA : Register
			{
				
				private readonly IConsole Console = null;
				
				public DMA( IConsole Console ) : base()
				{
					this.Console = Console;
					return;
				}
				
				public override byte this[int Address]
				{
					set
					{
						Value = value;
						Address = ( value << 8 );
						for( int i = 0; i < 0xA0; i++, Address++ )
						{
							Console.Memory.WriteU8( 0xFE00 | i, Console.Memory.ReadU8( Address ) );
						}
					}
				}

			}
			
		}
		
	}
	
}
