using System;
using Collections = System.Collections.Generic;
using Forms = System.Windows.Forms;

using GameKnight.Core;

namespace GameKnight.Win32
{
	
	public sealed class InputDevice
	{
		
		private readonly ConfigFile ConfigFile = null;
		
		private readonly IController Controller = null;
		
		private readonly Collections.Dictionary<IControl,Forms.Keys> KeyList = new Collections.Dictionary<IControl,Forms.Keys>();
		
		public InputDevice( IController Controller, ConfigFile ConfigFile )
		{
			this.Controller = Controller;
			this.ConfigFile = ConfigFile;
			foreach( IControl CurrentControl in Controller.ControlArray )
			{
				Forms.Keys Key = Forms.Keys.None;
				ConfigFile.Get<Forms.Keys>( Controller.Name, CurrentControl.Name, ref Key );
				this.KeyList.Add( CurrentControl, Key );
			}
			return;
		}
		
		public Forms.Keys this[IControl Control]
		{
			get
			{
				return KeyList[Control];
			}
			set
			{
				KeyList[Control] = value;
				ConfigFile.Set<Forms.Keys>( Controller.Name, Control.Name, value );
			}
		}
		
		public bool this[Forms.Keys Key]
		{
			set
			{
				Collections.IEnumerator<Collections.KeyValuePair<IControl,Forms.Keys>> Enumerator = KeyList.GetEnumerator();
				do
				{
					if( ( Enumerator.Current.Key != null ) && ( Enumerator.Current.Value == Key ) )
					{
						Controller[Enumerator.Current.Key] = Convert.ToInt32( value );
						break;
					}
				}
				while( Enumerator.MoveNext() );
			}
		}
		
	}
	
}

